Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 1 | #!/bin/sh |
Greg Kroah-Hartman | b244131 | 2017-11-01 15:07:57 +0100 | [diff] [blame] | 2 | # SPDX-License-Identifier: GPL-2.0 |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 3 | # |
| 4 | # link vmlinux |
| 5 | # |
| 6 | # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and |
Nicholas Piggin | f49821e | 2018-02-11 00:25:04 +1000 | [diff] [blame] | 7 | # $(KBUILD_VMLINUX_MAIN) and $(KBUILD_VMLINUX_LIBS). Most are built-in.a files |
Nicholas Piggin | 3a166fc | 2017-06-20 01:52:05 +1000 | [diff] [blame] | 8 | # from top-level directories in the kernel tree, others are specified in |
| 9 | # arch/$(ARCH)/Makefile. Ordering when linking is important, and |
| 10 | # $(KBUILD_VMLINUX_INIT) must be first. $(KBUILD_VMLINUX_LIBS) are archives |
| 11 | # which are linked conditionally (not within --whole-archive), and do not |
| 12 | # require symbol indexes added. |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 13 | # |
| 14 | # vmlinux |
| 15 | # ^ |
| 16 | # | |
| 17 | # +-< $(KBUILD_VMLINUX_INIT) |
| 18 | # | +--< init/version.o + more |
| 19 | # | |
| 20 | # +--< $(KBUILD_VMLINUX_MAIN) |
Nicholas Piggin | f49821e | 2018-02-11 00:25:04 +1000 | [diff] [blame] | 21 | # | +--< drivers/built-in.a mm/built-in.a + more |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 22 | # | |
Nicholas Piggin | 3a166fc | 2017-06-20 01:52:05 +1000 | [diff] [blame] | 23 | # +--< $(KBUILD_VMLINUX_LIBS) |
| 24 | # | +--< lib/lib.a + more |
| 25 | # | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 26 | # +-< ${kallsymso} (see description in KALLSYMS section) |
| 27 | # |
| 28 | # vmlinux version (uname -v) cannot be updated during normal |
| 29 | # descending-into-subdirs phase since we do not yet know if we need to |
| 30 | # update vmlinux. |
| 31 | # Therefore this step is delayed until just before final link of vmlinux. |
| 32 | # |
| 33 | # System.map is generated to document addresses of all kernel symbols |
| 34 | |
| 35 | # Error out on error |
| 36 | set -e |
| 37 | |
| 38 | # Nice output in kbuild format |
| 39 | # Will be supressed by "make -s" |
| 40 | info() |
| 41 | { |
| 42 | if [ "${quiet}" != "silent_" ]; then |
| 43 | printf " %-7s %s\n" ${1} ${2} |
| 44 | fi |
| 45 | } |
| 46 | |
Nicholas Piggin | 3a166fc | 2017-06-20 01:52:05 +1000 | [diff] [blame] | 47 | # Thin archive build here makes a final archive with symbol table and indexes |
| 48 | # from vmlinux objects INIT and MAIN, which can be used as input to linker. |
| 49 | # KBUILD_VMLINUX_LIBS archives should already have symbol table and indexes |
| 50 | # added. |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 51 | # |
| 52 | # Traditional incremental style of link does not require this step |
| 53 | # |
Nicholas Piggin | f49821e | 2018-02-11 00:25:04 +1000 | [diff] [blame] | 54 | # built-in.a output file |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 55 | # |
| 56 | archive_builtin() |
| 57 | { |
Nicholas Piggin | f49821e | 2018-02-11 00:25:04 +1000 | [diff] [blame] | 58 | info AR built-in.a |
| 59 | rm -f built-in.a; |
| 60 | ${AR} rcsTP${KBUILD_ARFLAGS} built-in.a \ |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 61 | ${KBUILD_VMLINUX_INIT} \ |
| 62 | ${KBUILD_VMLINUX_MAIN} |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 63 | } |
| 64 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 65 | # Link of vmlinux.o used for section mismatch analysis |
| 66 | # ${1} output file |
| 67 | modpost_link() |
| 68 | { |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 69 | local objects |
| 70 | |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 71 | objects="--whole-archive \ |
Nicholas Piggin | f49821e | 2018-02-11 00:25:04 +1000 | [diff] [blame] | 72 | built-in.a \ |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 73 | --no-whole-archive \ |
| 74 | --start-group \ |
| 75 | ${KBUILD_VMLINUX_LIBS} \ |
| 76 | --end-group" |
| 77 | |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 78 | ${LD} ${LDFLAGS} -r -o ${1} ${objects} |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 79 | } |
| 80 | |
| 81 | # Link of vmlinux |
| 82 | # ${1} - optional extra .o files |
| 83 | # ${2} - output file |
| 84 | vmlinux_link() |
| 85 | { |
| 86 | local lds="${objtree}/${KBUILD_LDS}" |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 87 | local objects |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 88 | |
| 89 | if [ "${SRCARCH}" != "um" ]; then |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 90 | objects="--whole-archive \ |
Nicholas Piggin | f49821e | 2018-02-11 00:25:04 +1000 | [diff] [blame] | 91 | built-in.a \ |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 92 | --no-whole-archive \ |
| 93 | --start-group \ |
| 94 | ${KBUILD_VMLINUX_LIBS} \ |
| 95 | --end-group \ |
| 96 | ${1}" |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 97 | |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 98 | ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \ |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 99 | -T ${lds} ${objects} |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 100 | else |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 101 | objects="-Wl,--whole-archive \ |
Nicholas Piggin | f49821e | 2018-02-11 00:25:04 +1000 | [diff] [blame] | 102 | built-in.a \ |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 103 | -Wl,--no-whole-archive \ |
| 104 | -Wl,--start-group \ |
| 105 | ${KBUILD_VMLINUX_LIBS} \ |
| 106 | -Wl,--end-group \ |
| 107 | ${1}" |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 108 | |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 109 | ${CC} ${CFLAGS_vmlinux} -o ${2} \ |
| 110 | -Wl,-T,${lds} \ |
| 111 | ${objects} \ |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 112 | -lutil -lrt -lpthread |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 113 | rm -f linux |
| 114 | fi |
| 115 | } |
| 116 | |
| 117 | |
| 118 | # Create ${2} .o file with all symbols from the ${1} object file |
| 119 | kallsyms() |
| 120 | { |
| 121 | info KSYM ${2} |
| 122 | local kallsymopt; |
| 123 | |
| 124 | if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then |
James Hogan | 6895f97 | 2012-09-06 22:11:25 +0100 | [diff] [blame] | 125 | kallsymopt="${kallsymopt} --all-symbols" |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 126 | fi |
| 127 | |
Ard Biesheuvel | 4d5d566 | 2016-03-15 14:58:12 -0700 | [diff] [blame] | 128 | if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then |
Rusty Russell | c6bda7c | 2014-03-17 14:05:46 +1030 | [diff] [blame] | 129 | kallsymopt="${kallsymopt} --absolute-percpu" |
| 130 | fi |
| 131 | |
Ard Biesheuvel | 2213e9a | 2016-03-15 14:58:19 -0700 | [diff] [blame] | 132 | if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then |
| 133 | kallsymopt="${kallsymopt} --base-relative" |
| 134 | fi |
| 135 | |
Sam Ravnborg | 00e6c28c | 2012-05-08 19:53:46 +0200 | [diff] [blame] | 136 | local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \ |
| 137 | ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}" |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 138 | |
Ard Biesheuvel | a043934 | 2016-02-05 11:25:05 +0100 | [diff] [blame] | 139 | local afile="`basename ${2} .o`.S" |
| 140 | |
| 141 | ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile} |
| 142 | ${CC} ${aflags} -c -o ${2} ${afile} |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 143 | } |
| 144 | |
| 145 | # Create map file with all symbols from ${1} |
| 146 | # See mksymap for additional details |
| 147 | mksysmap() |
| 148 | { |
| 149 | ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2} |
| 150 | } |
| 151 | |
Linus Torvalds | 1347a2ce | 2012-05-28 10:32:28 -0700 | [diff] [blame] | 152 | sortextable() |
| 153 | { |
| 154 | ${objtree}/scripts/sortextable ${1} |
| 155 | } |
| 156 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 157 | # Delete output files in case of error |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 158 | cleanup() |
| 159 | { |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 160 | rm -f .tmp_System.map |
| 161 | rm -f .tmp_kallsyms* |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 162 | rm -f .tmp_vmlinux* |
Nicholas Piggin | f49821e | 2018-02-11 00:25:04 +1000 | [diff] [blame] | 163 | rm -f built-in.a |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 164 | rm -f System.map |
| 165 | rm -f vmlinux |
| 166 | rm -f vmlinux.o |
| 167 | } |
| 168 | |
Sylvain BERTRAND | ab160db | 2015-05-07 00:36:04 +0000 | [diff] [blame] | 169 | on_exit() |
| 170 | { |
| 171 | if [ $? -ne 0 ]; then |
| 172 | cleanup |
| 173 | fi |
| 174 | } |
| 175 | trap on_exit EXIT |
| 176 | |
| 177 | on_signals() |
| 178 | { |
| 179 | exit 1 |
| 180 | } |
| 181 | trap on_signals HUP INT QUIT TERM |
| 182 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 183 | # |
| 184 | # |
| 185 | # Use "make V=1" to debug this script |
| 186 | case "${KBUILD_VERBOSE}" in |
| 187 | *1*) |
| 188 | set -x |
| 189 | ;; |
| 190 | esac |
| 191 | |
| 192 | if [ "$1" = "clean" ]; then |
| 193 | cleanup |
| 194 | exit 0 |
| 195 | fi |
| 196 | |
| 197 | # We need access to CONFIG_ symbols |
Michal Marek | 423a815 | 2013-02-25 13:47:53 +0100 | [diff] [blame] | 198 | case "${KCONFIG_CONFIG}" in |
| 199 | */*) |
| 200 | . "${KCONFIG_CONFIG}" |
| 201 | ;; |
| 202 | *) |
| 203 | # Force using a file from the current directory |
| 204 | . "./${KCONFIG_CONFIG}" |
| 205 | esac |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 206 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 207 | # Update version |
| 208 | info GEN .version |
Masahiro Yamada | 278ae60 | 2017-09-22 14:31:13 +0900 | [diff] [blame] | 209 | if [ -r .version ]; then |
| 210 | VERSION=$(expr 0$(cat .version) + 1) |
| 211 | echo $VERSION > .version |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 212 | else |
Masahiro Yamada | 278ae60 | 2017-09-22 14:31:13 +0900 | [diff] [blame] | 213 | rm -f .version |
| 214 | echo 1 > .version |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 215 | fi; |
| 216 | |
| 217 | # final build of init/ |
Cao jin | a7b151f | 2018-02-21 12:25:07 +0800 | [diff] [blame] | 218 | ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 219 | |
Nicholas Piggin | abac4c8 | 2016-11-24 03:41:43 +1100 | [diff] [blame] | 220 | archive_builtin |
| 221 | |
| 222 | #link vmlinux.o |
| 223 | info LD vmlinux.o |
| 224 | modpost_link vmlinux.o |
| 225 | |
| 226 | # modpost vmlinux.o to check for section mismatches |
| 227 | ${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o |
| 228 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 229 | kallsymso="" |
| 230 | kallsyms_vmlinux="" |
| 231 | if [ -n "${CONFIG_KALLSYMS}" ]; then |
| 232 | |
| 233 | # kallsyms support |
| 234 | # Generate section listing all symbols and add it into vmlinux |
| 235 | # It's a three step process: |
| 236 | # 1) Link .tmp_vmlinux1 so it has all symbols and sections, |
| 237 | # but __kallsyms is empty. |
| 238 | # Running kallsyms on that gives us .tmp_kallsyms1.o with |
| 239 | # the right size |
| 240 | # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of |
| 241 | # the right size, but due to the added section, some |
| 242 | # addresses have shifted. |
| 243 | # From here, we generate a correct .tmp_kallsyms2.o |
Nicholas Piggin | 7e2b37c | 2016-11-24 03:41:37 +1100 | [diff] [blame] | 244 | # 3) That link may have expanded the kernel image enough that |
| 245 | # more linker branch stubs / trampolines had to be added, which |
| 246 | # introduces new names, which further expands kallsyms. Do another |
| 247 | # pass if that is the case. In theory it's possible this results |
| 248 | # in even more stubs, but unlikely. |
| 249 | # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around |
| 250 | # other bugs. |
| 251 | # 4) The correct ${kallsymso} is linked into the final vmlinux. |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 252 | # |
| 253 | # a) Verify that the System.map from vmlinux matches the map from |
| 254 | # ${kallsymso}. |
| 255 | |
| 256 | kallsymso=.tmp_kallsyms2.o |
| 257 | kallsyms_vmlinux=.tmp_vmlinux2 |
| 258 | |
| 259 | # step 1 |
| 260 | vmlinux_link "" .tmp_vmlinux1 |
| 261 | kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o |
| 262 | |
| 263 | # step 2 |
| 264 | vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2 |
| 265 | kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o |
| 266 | |
Nicholas Piggin | 7e2b37c | 2016-11-24 03:41:37 +1100 | [diff] [blame] | 267 | # step 3 |
Michael Forney | a670b0b | 2018-03-18 17:54:02 -0700 | [diff] [blame] | 268 | size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o) |
| 269 | size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o) |
Nicholas Piggin | 7e2b37c | 2016-11-24 03:41:37 +1100 | [diff] [blame] | 270 | |
| 271 | if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 272 | kallsymso=.tmp_kallsyms3.o |
| 273 | kallsyms_vmlinux=.tmp_vmlinux3 |
| 274 | |
| 275 | vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3 |
| 276 | |
| 277 | kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o |
| 278 | fi |
| 279 | fi |
| 280 | |
| 281 | info LD vmlinux |
| 282 | vmlinux_link "${kallsymso}" vmlinux |
| 283 | |
Linus Torvalds | 1347a2ce | 2012-05-28 10:32:28 -0700 | [diff] [blame] | 284 | if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then |
| 285 | info SORTEX vmlinux |
| 286 | sortextable vmlinux |
| 287 | fi |
| 288 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 289 | info SYSMAP System.map |
| 290 | mksysmap vmlinux System.map |
| 291 | |
| 292 | # step a (see comment above) |
| 293 | if [ -n "${CONFIG_KALLSYMS}" ]; then |
| 294 | mksysmap ${kallsyms_vmlinux} .tmp_System.map |
| 295 | |
| 296 | if ! cmp -s System.map .tmp_System.map; then |
Michal Marek | 5369f55 | 2012-07-07 23:04:40 +0200 | [diff] [blame] | 297 | echo >&2 Inconsistent kallsyms data |
Michal Marek | 367e43c | 2012-08-10 11:55:11 +0200 | [diff] [blame] | 298 | echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 299 | exit 1 |
| 300 | fi |
| 301 | fi |